import { useEffect, useRef } from "react";
export function useAbandonedRenderDisposer(dispose) {
    const tracker = useRef(null);
    if (tracker.current === null) {
        tracker.current = setTimeout(dispose, 5 * 60 * 1000);
    }
    useEffect(() => {
        if (tracker.current !== null) {
            clearTimeout(tracker.current);
        }
    }, []);
}
//# sourceMappingURL=useAbandonedRenderDisposer.js.map